#include<fstream>
#include <algorithm>
using namespace std;
ifstream fi("SortMT.inp");
ofstream fo("SortMT.out");
int n,m;
int main()
{
	fi>>n>>m;
	int a[n][m];
	int b[m];
	int max=-109;
	int min=109;
	for(int i=0;i<n;i++)
	{
		for(int j=0;j<m;j++)
		{
			fi>>a[i][j];
			b[j]=a[i][j];
		}
		sort(b,b+m);
		if(b[0]<min)
		{
			min=b[0];
		}
		if(b[m-1]>max)
		{
			max=b[m-1];
		}
		for(int y=0;y<m;y++)
		{
			a[i][y]=b[y];
		}
	}
	fo<<max<<" "<<min<<endl;
	for(int i=0;i<n;i++)
	{
		for(int j=0;j<m;j++)
		{
			fo<<a[i][j]<<" ";
		}
		fo<<endl;
	}
	fi.close();
	fo.close();
}
